﻿#pragma once

#include <windows.h>
#include <winnt.h>
#include <exception>
#include <rttidata.h>

static inline _RTTICompleteObjectLocator* GetCompleteObjectLocatorFromObject(void* pointerToObject)
{
    // Ptr to CompleteObjectLocator should be stored at vfptr[-1]
    auto  obj = static_cast<_RTTICompleteObjectLocator***>(pointerToObject)[0][-1];
    if(obj == nullptr)
    {
        uintptr_t offset = static_cast<uint32_t**>(pointerToObject)[0][1];
        pointerToObject = (char*)pointerToObject + offset;
        return static_cast<_RTTICompleteObjectLocator***>(pointerToObject)[0][-1];
    }
    return obj;
}

#if _RTTI_RELATIVE_TYPEINFO
static inline uintptr_t GetImageBase(const void* pCallerPC)
{
    void* _ImageBase;
    _ImageBase = RtlPcToFileHeader(
        const_cast<void*>(pCallerPC),
        &_ImageBase);
    return reinterpret_cast<uintptr_t>(_ImageBase);
}

static inline uintptr_t GetImageBaseFromCompleteObjectLocator(
    const _RTTICompleteObjectLocator* const pCompleteLocator
)
{
    if(pCompleteLocator->signature == COL_SIG_REV0)
    {
        return GetImageBase(pCompleteLocator);
    }

    return reinterpret_cast<uintptr_t>(pCompleteLocator)
        - ((uintptr_t)pCompleteLocator->pSelf);
}
#endif
static ptrdiff_t PMDtoOffset(
    void* pThis,           // ptr to complete object
    const PMD& pmd)         // pointer-to-member-data structure
{
    ptrdiff_t RetOff = 0;

    if(pmd.pdisp >= 0)
    {
        // if base is in the virtual part of class
        RetOff = pmd.pdisp;
        RetOff += *(__int32*)((char*)*(ptrdiff_t*)((char*)pThis + RetOff) +
                                pmd.vdisp);
    }

    RetOff += pmd.mdisp;

    return RetOff;
}
